clear all
close all
clc
data.xdata = [28    55    83    110   138   225   375]';   % x (mg / L COD) 
data.ydata = [0.053 0.060 0.112 0.105 0.099 0.122 0.125]'; % y (1 / h) 



modelfun = @(x,theta) theta(1)*x./(theta(2)+x);
ssfun    = @(theta,data) sum((data(:,2)-modelfun(data(:,1),theta)).^2);




tmin =[0.1454 49.0530];


ssmin = 8.1677e-004;

n = length(data.xdata);
p = 2;
mse = ssmin/(n-p) ;

% Initial (prior) covariance
J = [data.xdata./(tmin(2)+data.xdata), ...
     -tmin(1).*data.xdata./(tmin(2)+data.xdata).^2];
tcov = inv(J'*J)*mse;

options_.mh_sigma2 = mse;
options_.mh_replic = 500;

options_.mh_npars = 2;
options_.mh_updatesigma =1;
% % % options_.mh_incov = tcov;
options_.mh_modelfun = modelfun;
options_.mh_ssfun = ssfun;
options_.mh_burnintime=0;
options_.mh_adaptint = 25;
options_.mh_noadaptind =[];  
options_.mh_dostats=0;
options_.mh_adascale=[];
options_.mh_priortype=1; 
options_.mh_priorupdatefun=[];
options_.mh_N=7;
options_.mh_S20=NaN ;  
options_.mh_N0=1;  
options_.mh_exchangeint=50;
otpions.method='am';
vv=tcov;
TargetFun=ssfun;
xparam=tmin;
mh_bounds=[0 Inf; 0,Inf];
varargin{2}=[data.xdata data.ydata]; 
varargin{1}=7; 

[MarkovChain,options_,params]=AdaMetropolis(TargetFun,xparam,vv,mh_bounds,options_,varargin);
plot(MarkovChain)


% for replica exchange
PP=[tmin' [0.145 52]'];
options_.mh_params.low=[0 0; 0 0];
options_.mh_params.upp=[Inf Inf; Inf Inf];

[chain10,options_] = RepEXMCMC(PP,options_,varargin);
figure, plot(chain10)
return


